###############################################################################
####### lalinference_pipe example initialisation file #########################
####### For more information, see docs page at        #########################
# https://www.lsc-group.phys.uwm.edu/ligovirgo/cbcnote/ParameterEstimationModelSelection/LALInference_HowTo
###############################################################################

[analysis]
# IFOs to use for this analysis
ifos=['H1','L1','V1']

# select the engine to use, lalinferencenest, lalinferencemcmc or lalinferencebambimpi
# A comma separated list can be provided. In that case a dag for each sampler will be created, along with a top level dag to run them all, e.g.
# engine=lalinferencenest,lalinferencemcmc
engine=lalinferencenest

# Number of parallel runs for each event. Using parallel runs increases the number of sample, giving a better exploration of the parameter space.
# Default 2 for lalinferencemcmc, 1 for lalinference_bambi and 4 for lalinferencenest.
nparallel=5

# Turn the coherence test?
coherence-test=False

# Upload results to the gravitational-wave events database?
upload-to-gracedb=False
# Add the lvem tag to the sky maps and extrinsic triangle plot to share with EM partners
add-lvem-tag=False
# service-url for gracedb, ex. https://gracedb-playground.ligo.org/api/ for O2Replay. Leave commented out for default, https://gracedb.ligo.org/api/.
# service-url=https://gracedb.ligo.org/api/

#chain seed (incremented by one for each parallel chain). If commented the cpu time will be used to initialize the chain.
# randomseed=4321

# noise generator seed (incremented by eventnum for each event). If set to 0 the cpu time will be used to initialize the noise generator (that may make it problematic to reproduce results). Mandatory parameter when using fake-cache in the [lalinference] section.
# dataseed=1234

# Whether to run with Reduced Order Quadrature
roq=False

# Run engine jobs via Singularity wrapping
singularity=False

# Run on the Open Science Grid
osg=False

#####################################################################################
[paths]
# the following can be given with command line (see below)
#webdir is the base output dir for results pages
webdir=/home/albert.einstein/public_html/lalinferenceresults/

#roq_b_matrix_directory is the location of the ROQ basis when using the ROQ likelihood
roq_b_matrix_directory=/home/cbc/ROQ_data/IMRPhenomPv2/

#####################################################################################
[input]
# User-specified length of the psd. if not specified, will be automatically calculated from segment availability
# psd-length=1024

# User-specified psd start time (used for manual over-ride, if not given pipeline determines this automatically)
# psd-start-time= 968621415

# Maximum length to use for automatically-determined psdlength options
max-psd-length=1024

# spacing between trigger times and start of psd estimation
padding=16

# all will analyze all the events in the injetion table. Ranges and/or single events can also be specified. E.g. events=[0,4,5,10:12] will analyze the event 0,4,5,10,11,12.
events=all

# Overlap between segments when analysing a continuous span of time
# segment-overlap=32

# Can manually over-ride time limits here.
# If analysing a continuous stretch of time the start and end times must
# be given. Otherwise can be ignored unless selecting only certain event times from input files
#gps-start-time=
#gps-end-time=
# This option turns on the analysis of a continuous stretch of time.
analyse-all-time=False

# Can manually specify input files here or over-ride on the command line
#gps-time-file=
#injection-file=
#coinc-xml=
#psd-xml-gz=
#pipedown-db=
#gstlal-db=

# If this option is set "true" and a pipedown database is used as input, the pipeline will analyse the time slide events
timeslides=false

# This can be used (when running with a trigtime file) to timeslide the data in each interferometer.
# Pass an ascii file with 1 row per each trigtime (obviously, in the same order given in the trigtime file)
# The colum order must be the same as the ifos options at the top of this file
# Notice that the amount given in the timeslides will be **subtracted** from trigtime when timesliding.
# So, if ifos=['H1','L1'], a timeslide row like "0  -10" will leave H1 data the same and **add** ten seconds to L1 data.
#timeslides-ascii=/path/to/file.txt


# Uncomment the following line to ignore state vectors. Useful when using fake noise
ignore-state-vector=True

# Uncomment the following line to ignore the psd.xml.gz file when analyzing a gracedb event.
#ignore-gracedb-psd=True

# If the following number is specfied, only ifos which can provide more noise
# realizations for PSD estimation are selected.
# minimum_realizations_number=8

# Options to select events from SQLite databases (optional)
# Select combined false alarm rate in Hz
# min-cfar = 0
# max-cfar = 1e-6

# Option to specify text file for dumping time slide information
#time-slide-dump=path/to/file

#####################################################################################
[condor]
# Replace with your own executable locations

# Can use this option to specify the installation location
# and interpolate the exe paths
lalsuite-install=/home/albert.einstein/opt/lalsuite/

datafind=%(lalsuite-install)s/bin/gw_data_find
mergeNSscript=%(lalsuite-install)s/bin/lalinference_nest2pos
mergeMCMCscript=%(lalsuite-install)s/bin/cbcBayesMCMC2pos
combinePTMCMCh5script=%(lalsuite-install)s/bin/cbcBayesCombinePTMCMCh5s

# You can use either cbcBayesPostProc or PESummary to generate the summarypages.
# PESummary code from https://git.ligo.org/lscsoft/pesummary
# To install PESummary see https://docs.ligo.org/lscsoft/pesummary/installation.html
resultspage=%(lalsuite-install)s/bin/cbcBayesPostProc
# resultspage=%(lalsuite-install)s/bin/summarypages

segfind=%(lalsuite-install)s/bin/ligolw_segment_query
ligolw_print=%(lalsuite-install)s/bin/ligolw_print
coherencetest=%(lalsuite-install)s/bin/lalinference_coherence_test
lalinferencenest=%(lalsuite-install)s/bin/lalinference_nest
lalinferencemcmc=%(lalsuite-install)s/bin/lalinference_mcmc
lalinferencebambi=%(lalsuite-install)s/bin/lalinference_bambi
lalinferencedatadump=%(lalsuite-install)s/bin/lalinference_datadump
# Bayeswave code from https://wiki.ligo.org/Bursts/BayesWave/RunningBayesWaveBurst
# Disabled by default, uncomment lines below to use it (Need both BayesWave and BayesWavePost)
# bayeswave=%(lalsuite-install)s/bin/BayesWave
# bayeswavepost = %(lalsuite-install)s/bin/BayesWavePost

# When using BayesWave, set how much memory is required.
# This varies with the bandwidth & seglen used, but a suggestion of 
# BW -> 1000 MB, BWP -> 4000 MB for BBH and NSBH
# BW -> 16000 MB, BWP -> 16000 MB for BNS
# note that these values most likely needs to be modified for your specific analysis
bayeswave_request_memory = 1000
bayeswavepost_request_memory = 4000



ligo-skymap-from-samples=%(lalsuite-install)s/bin/ligo-skymap-from-samples
ligo-skymap-plot=%(lalsuite-install)s/bin/ligo-skymap-plot
# To have 2D sky PP plot while running the PP pipeline both skyareas above and processareas below must be given
# Comment line below not to use it
processareas=%(lalsuite-install)s/bin/process_areas

# ROQ weight computation, requires roq_b_matrix_directory in the [paths] section
# and roq=True in the [analysis] section
computeroqweights=%(lalsuite-install)s/bin/lalinference_compute_roq_weights

# MPIrun only needed for MCMC, if not available use /bin/true
mpirun=mpirun

# Wrapper script for MPI jobs
mpiwrapper=%(lalsuite-install)s/bin/lalinference_mpi_wrapper

# GraceDB only needed for online analysis, if not available use /bin/true
gracedb=%(lalsuite-install)s/bin/gracedb

# Scripts needed only for PP check pipeline
ppanalysis=%(lalsuite-install)s/bin/cbcBayesPPAnalysis
pos_to_sim_inspiral=%(lalsuite-install)s/bin/cbcBayesPosToSimInspiral

# Location of singularity for running on OSG
# Must also add an image file in the [singularity] section
#singularity=/bin/singularity

# Queue information if needed to run on specific nodes
#queue=

# Set specific nodes requirements if needed, for instance:
#queue=

# Set specific nodes requirements if needed, for instance:
#Requirements = regexp(“Intel”, TARGET.cpuinfo_model_name)

# Uncomment to get condor notifications for the engine job
# this will use the email address from the [resultspage] section
#notification=Complete

# Analysis type for accounting for computing use
# See https://ldas-gridmon.ligo.caltech.edu/accounting/condor_groups/determine_condor_account_group.html
# !!! If omitted, jobs may not run on all LDG clusters !!!
# Common choices are:
# ligo.dev.o1.cbc.pe.lalinferenceonline - day-latency followup for O1 development
# ligo.dev.o1.cbc.pe.lalinference - follow up for detection candidates for O1 development
# ligo.dev.o1.cbc.noise.lalinference - noise modelling for O1 development
# ligo.dev.o1.cbc.testgr.tiger - TIGER for O1 development
#
# Replace dev with sim or prod for simulation or production runs
# Replace o1 with s6,o2,o3 for other runs
#
accounting_group=ligo.dev.o2.cbc.pe.lalinference

# May specify desired sites for running on the Open Science grid
#desired-sites=

#####################################################################################
# Section used by the datafind jobs (not used with simulated noise)
[datafind]
# Specifies we look for data in the local filesystem (as opposed to remote data)
url-type=file

# Can specify veto categories here (default to using no vetoes)
# veto-categories=

# "type" of frames to look for with gw_data_find
# e.g O2 final calibration offline data
types={'H1':'H1_HOFT_C02','L1':'L1_HOFT_C02','V1':'V1O2Repro2A'}

# O3 offline frame types:
#types={'H1':'H1_HOFT_C00','L1':'L1_HOFT_C00','V1':'V1Online'}

# O3 online frame types
#types={'H1':'H1_llhoft','L1':'L1_llhoft','V1':'V1_llhoft'}

#####################################################################################
[data]
# Channels to use to read h(t) from frame files
# S5 has LSC-STRAIN, S6 has LDAS-STRAIN, ER7/O1 has e.g. H1:GDS-CALIB_STRAIN
# S5 has LSC-STRAIN, S6 has LDAS-STRAIN
# Low-latency O1/O2 calibrated H1:GDS-CALIB_STRAIN, V1:Hrec_hoft_16384Hz
# Low-latency O3 calibrated and cleaned H1:GDS-CALIB_STRAIN_CLEANED, V1:Hrec_hoft_16384Hz
# e.g. Offline O2 channels:
channels={'H1':'H1:DCS-CALIB_STRAIN_C02','L1':'L1:DCS-CALIB_STRAIN_C02','V1':'V1:Hrec_hoft_16384Hz'}


#####################################################################################
[lalinference]

# fake-cache is used to specify the fake names for simulated data
# For simulated LIGO noise use 'LALLIGO', Virgo noise: 'LALVirgo'
# For simulated advanced detectors use 'LALSimAdLIGO' and 'LALSimAdVirgo'
# If not enabled, the pipeline will look for real data
#fake-cache={'H1':'LALSimAdLIGO','L1':'LALSimAdLIGO','V1':'LALSimAdVirgo'}

# fLow can be used to specify the low frequency cutoff for each detector
# Default is 20 Hz
# flow = {'H1':20,'L1':20,'V1':20}

#####################################################################################
[engine]
# All options in this section are passed to lalinference_nest, lalinference_mcmc,
# and lalinference_bambi. Some useful ones are noted below.
# Options passed to a sampler which does not know them will simply be ignored

# REQUIRED SETTINGS:
# Nlive specifies the number of live points for each job
nlive=512

# OPTIONAL SETTINGS:

# Sampling rate for data
srate=2048

# Segment length to use for analysis (should be long enough for whole template
seglen=32

# Reference frequency for time-varying parameters (applicable to precessing templates)
fref=100
#inj-fref=100

# Marginalisation over calibration uncertainty
#enable-spline-calibration=
# Set the number of spline nodes per detector (default 5)
#spcal-nodes=N
# Set the prior on relative amplitude uncertainty (default 0.1)
#H1-spcal-amp-uncertainty=0.1@
#L1-spcal-amp-uncertainty=0.1@
# Set the prior on phase uncertanity in degrees (default 5)
#H1-spcal-phase-uncertainty=5
#L1-spcal-phase-uncertainty=5

# Use lalinference's resume ability if the run is interrupted. Comment out to disable.
resume=
# lalinference_bambi automatically resumes, use this if you want to force a start from scratch
#noresume=

# approx is used to specify an approximant, it can either be a single approximant or a comma separated list e.g.
# approx=TaylorF2threePointFivePN,IMRPhenomPv2
# If a list is given, a dag for each approximant will be created and an upper level dag will control them
# All the dirs (including webdir) will be given an appropriate suffix
approx=SEOBNRv2_ROM_DoubleSpinpseudoFourPN,IMRPhenomPv2pseudoFourPN

# Control the amplitude order (default: max available)
# Ignored by the EOBNR and IMRPhenom families
# WARNING: affects the starting frequency of waveform generation
amporder=0

# maxmcmc set the maximum chain length for the nested sampling sub-chains. Default 5000
# Auto determination is on, but the length cannot be longer than that.
#maxmcmc=5000

# Number of independent sample to obtain before quitting for lalinference_mcmc
neff=1000

# Adapt temperatures to achieve ~uniform swap acceptance rates
adapt-temps=

# Priors
# For all parameters known to lalinference, the min and max default prior can be overwritten with
#parname-min=MIN
#parname-max=MAX

# The starting point for the MCMC chain(s) can be specified with
#parname=START

# Parameters can be fixed to some value with
#fix-parname=FIXVALUE

#currently known parameters, together with default [min-max] are (radians for angle, Mpc for distance, Msun for masses)

#time                         Waveform time [trigtime-0.1-trigtime+0.1]
#chirpmass                    Chirpmass [1,15.3]
#eta                          Symmetric massratio (needs --use-eta) [0,0.0312]
#q                            Asymmetric massratio (a.k.a. q=m2/m1 with m1>m2) [0.033,1]
#phase                        Coalescence phase [0,2Pi]
#costheta_jn                  Cosine of angle between J and line of sight [-1,1]
#logdistance                  Log Distance [log(1),log(2000)]
#rightascension               Rightascension [0,2Pi]
#declination                  Declination [-Pi/2,Pi/2]
#polarisation                 Polarisation angle [0,Pi]

#Spin Parameters:
#a_spin1                      Spin1 magnitude [-1,1] for aligned, [0,1] for precessing
#a_spin2                      Spin2 magnitude [-1,1] for aligned, [0,1] for precessing
#tilt_spin1                   Angle between spin1 and orbital angular momentum [0,Pi]
#tilt_spin2                   Angle between spin2 and orbital angular momentum  [0, Pi]
#phi_12                       Difference between spins' azimuthal angles [0,2Pi]
#phi_jl                       Difference between total and orbital angular momentum azimuthal angles [0,2Pi]

#Tidal parameters (requires tidal= or tidalT=):
#lambda1                      lambda1 [0,3000]
#lambda2                      lambda2 [0,3000]
#lambdaT                      lambdaT [0,3000]
#dLambdaT                     dLambdaT [-500,500]

#Equation of State parameters (requires 4PolyEOS=):
#logp1                        logp1 [33.6,35.4]
#gamma1                       gamma1 [2.0,4.5]
#gamma2                       gamma2 [1.1,4.5]
#gamma3                       gamma3 [1.1,4.5]

#Common EoS tidal model for BNS systems (requires BinaryLove=)
#lambdaS                      Symmetric tidal deformability, (lambda1+lambda2)/2 [0,5000]

#Equation of State parameters (requires 4SpectralDecomp=):
#SDgamma0                       SDgamma0 [0.2,2.0]
#SDgamma1                       SDgamma1 [-1.6,1.7]
#SDgamma2                       SDgamma2 [-0.6,0.6]
#SDgamma3                       SDgamma3 [-0.02,0.02]

# Settings for allowed component masses in Solar Masses, with default values
#comp-max=30.0
#comp-min=1.0

# Allowed total masses in Msun (note, used together with component masses, mc,q,eta priors may lead to inconsistencies. Be careful!)
#mtotal-max=35
#mtotal-min=2

# Setting time prior [seconds]
#dt=0.1

# The following options are for using analytic test functions
#correlatedGaussianLikelihood=
#bimodalGaussianLikelihood=
#rosenbrockLikelihood=

# The following options control various marginalised likelihoods.

# Analytically marginalise over phase (only for Newtonian amplitude orders)
margphi=
# Semi-analytically marginalise over time
#margtime=

# Semi-analytically marginalise over time and phase (only for Newtonian amplitude orders)
#margtimephi=

# Marginalise over distance using the bayestar method. Requires either --margphi or --margtimephi
# Euclidean cosmology (p(r) ~ r^2)
#margdist=
# Uniform in comoving distance
#margdist-comoving=

# By default the code use spins if the choosen approximant supports spin. NOTE that this include TaylorF2, which will be run with aligned spins.
# Several options, here below,  allows the user to choose a particular setting:

#Disable spin for waveforms which would normally have spins
disable-spin=

# Only allow aligned spins
#aligned-spin=

# Only allow the heavier mass to spin (can be used together with aligned-spin)
#singleSpin=

# Print progress information throughout the run
progress=

# lalinference_bambi allows you to set a target efficiency and tolerance - these are default values
#eff=0.1
tol=1.0

# lalinference_nest tolerance
tolerance=0.1

# Sample in eta instead than q=m2/m1
#use-eta=

# Force a zero-noise realisation
#0noise=

# optional number of temperature chains for MCMC
ntemps=8

#####################################################################################
[mpi]
# Settings when running with MPI for lalinference_mcmc or lalinference_bambi

# number of CPUs desired and how much memory on each (MB)
mpi_task_count=8
machine-count=8
machine-memory=4000

#####################################################################################
[resultspage]
# Settings for the results pages (see cbcBayesPostProc --help for more)

# Size of the side of the sky bins in degrees
skyres=0.5

# Create 2D plots, which take a while to generate
# plot-2d=

# For lalinferencemcmc, select points for plotting only after the chains have
# reached a log posterior of at least max_log_posterior_found-<deltaLogP>.
# This deltaLogP value should be the number of signal parameters divided by 2.
#deltaLogP=4

# CSVs for analytic tests
#meanVectors=unimodal_test_means.csv
#covarianceMatrix=test_correlation_matrix.csv

# Send an email linking to the final page
#email=albert.einstein@ligo.org

# Generate a plot showing the strain data at time of merger with the maxL
# waveform superimposed. Can only be used when the resultpage executable
# is resultspage=%(lalsuite-install)s/bin/summarypages
#plot-strain-data=

# Label for your analysis. Can either be a single label or a comma seperated
# list e.g. label = EXP0,EXP1. Can only be used when the resultpage executable
# is resultspage=%(lalsuite-install)s/bin/summarypages
#label = EXP1

#####################################################################################

[statevector]
# Channel of state vector referred to.
state-vector-channel={'H1': 'H1:GDS-CALIB_STATE_VECTOR', 'L1': 'L1:GDS-CALIB_STATE_VECTOR', 'V1': 'V1:DQ_ANALYSIS_STATE_VECTOR'}

# Bits of state vector channel referred to. Use only data during the time when
# the following bits are active. The meaning of each bit is summarized in
# https://wiki.ligo.org/Calibration/TDCalibReview and
# https://dcc.ligo.org/cgi-bin/private/DocDB/ShowDocument?docid=G1801125&version= .
# The most important bits for PE are
# Bit 0: HOFT_OK: h(t) was successfully computed
# Bit 1: OBSERVATION_INTENT: "observation intent" button is pushed
# Bit 2: OBSERVATION_READY: observation ready data is available
bits=['Bit 0', 'Bit 1', 'Bit 2']

#####################################################################################

[ppanalysis]
# This section only used with lalinference_pp_pipe
# Webdir is the output path for the PP check page
webdir=/home/albert.einstein/public_html/lalinference/review/PPcheck/

#####################################################################################
[bayeswave]

# This section defines configuration options for BayesWave
# and its RJMCMC sampler

# number of RJMCMC iterations (BW default 4000000)
Niter=100000
# number of parallel chains of RJMCMC sampler (BW default 20)
Nchain=10
# number of model updates per RJMCMC iteration (BW default 100)
#Ncycle=100
# number of burn-in iterations (BW default 50000)
#Nburnin=50000
# maximum number of wavelets per channel (BW default 100)
Dmax=200

#####################################################################################

[skyarea]
# Optional arguments:

# maximum number of posterior samples to use
maxpts=2000
#trials=50 # Maximum number of trials to build sky posterior
#noskyarea # Turn off sky area computation
#nside=512 # HEALPix resultion (default 512)
#seed=1234 # Random seed to use

[singularity]
# When requesting a run via singularity (on the OSG), must specify
# the location of an image
#image=/cvmfs/ligo-containers.opensciencegrid.org/john-veitch/lalinf_docker_test:latesti

[ligo-skymap-from-samples]
# Optional arguments for ligo-skymap-from-samples, from ligo.skymap module

[ligo-skymap-plot]
# optional arguments for ligo-skymap-plot, from ligo.skymap module

